local Fruit = class("Fruit")

function Fruit:init()

	self.sound = love.audio.newSource("graphics/coin.wav", "static")

	self.fruit1 = love.graphics.newImage("graphics/fruit1.png")
	self.fruit2 = love.graphics.newImage("graphics/fruit2.png")
	self.fruit3 = love.graphics.newImage("graphics/fruit3.png")
	self.fruit4 = love.graphics.newImage("graphics/fruit4.png")
	self.fruit5 = love.graphics.newImage("graphics/fruit5.png")
	
	self.image = self.fruit1
	self:setRandomImage()

end

function Fruit:setRandomImage()

	ranFruit = love.math.random(1,5)
	if(ranFruit == 1)then
		self.image = self.fruit1
	end
	if(ranFruit == 2) then
		self.image = self.fruit2
	end
	if(ranFruit == 3) then
		self.image = self.fruit3
	end
	if(ranFruit == 4) then
		self.image = self.fruit4
	end
	if(ranFruit == 5) then
		self.image = self.fruit5
	end
end

function Fruit:registerPlayers(p1,p2)
	self.player1 = p1
	self.player2 = p2
end

function Fruit:draw()
	love.graphics.draw(self.image, self.x, self.y)
end

function Fruit:newFruit()

	self:setRandomImage()
	newX = love.math.random(60,1200)
	newY = love.math.random(60,620)
	newX = math.floor(newX/40)
	newY = math.floor(newY/40)
	newX = (newX * 40) - 20
	newY = (newY * 40) - 20
	self.x = newX
	self.y = newY
	
	tailCollision = false
	
	if(self.player1.tailFront ~= nil) then -- Nicht im Schwanz von Player1 spawnen
		tailCollision = self.player1.tailFront:checkCollision(self.x, self.y)
	end
	if((self.player2 ~= nil) and (tailCollision == false)) then  -- Nicht im Schwanz von Player2 spawnen
		if(self.player2.tailFront ~= nil) then
			tailCollision = self.player2.tailFront:checkCollision(self.x, self.y)
		end
	end
	if(tailCollision == false) then  -- Nicht im Kopf von Player1 spawnen
		tailCollision = (self.player1:checkCollision(self.x,self.y))
	end
	if((self.player2 ~= nil) and (tailCollision == false)) then  -- Nicht im Kopf von Player2 spawnen
		tailCollision = (self.player2:checkCollision(self.x,self.y))
	end
	
	if(tailCollision) then
		self:newFruit()
	end
	
end

function Fruit:checkCollision(headX,headY)
	collision = (headX > self.x-40 and headX < self.x+40 and headY > self.y-40 and headY < self.y+40)
	if(collision)then
		love.audio.play(self.sound)
	end
	return collision
end

return Fruit()