Head = class("Head")
require 'tail'


function Head:init(id)
	
	self.id = id
	self.y = 340
	self.directionY = 0
	self.points = 0
	self.joystick = nil

	if(id == 1)then
		self.x = 420
		self.image_N = love.graphics.newImage("graphics/head_N.png")
		self.image_O = love.graphics.newImage("graphics/head_O.png")
		self.image_S = love.graphics.newImage("graphics/head_S.png")
		self.image_W = love.graphics.newImage("graphics/head_W.png")
		self.image = self.image_W
		self.directionX = 0
		self.tailEnd = Tail(self.id,self.x+80,self.y,nil)
		self.tailFront = Tail(self.id,self.x+40,self.y,self.tailEnd)
		self.tailEnd:setUp(self.tailFront)
	else
		self.x = 800
		self.image_N = love.graphics.newImage("graphics/head2_N.png")
		self.image_O = love.graphics.newImage("graphics/head2_O.png")
		self.image_S = love.graphics.newImage("graphics/head2_S.png")
		self.image_W = love.graphics.newImage("graphics/head2_W.png")
		self.image = self.image_O
		self.directionX = 0
		self.tailEnd = Tail(self.id,self.x-80,self.y,nil)
		self.tailFront = Tail(self.id,self.x-40,self.y,self.tailEnd)
		self.tailEnd:setUp(self.tailFront)
	end
end

function Head:setEnemy(enemy)
	self.enemy = enemy
end

function Head:setJoystick(joystick)
	self.joystick = joystick
end

function Head:reset()

	self.y = 340
	self.directionY = 0
	self.points = 0

	if(self.id == 1)then
		self.x = 420
		self.image = self.image_W
		self.directionX = 0
		self.tailEnd = Tail(self.id,self.x+80,self.y,nil)
		self.tailFront = Tail(self.id,self.x+40,self.y,self.tailEnd)
		self.tailEnd:setUp(self.tailFront)
	else
		self.x = 800
		self.image = self.image_O
		self.directionX = 0
		self.tailEnd = Tail(self.id,self.x-80,self.y,nil)
		self.tailFront = Tail(self.id,self.x-40,self.y,self.tailEnd)
		self.tailEnd:setUp(self.tailFront)
	end
end

function Head:moveLeft()
	if(self.directionX == 0 and self.directionY== 0 and self.id == 2)then
		return
	end
	if(self.directionX == 0)then
		self.directionX = -1
		self.directionY = 0
		self.image = self.image_W
	end
end

function Head:moveRight()
	if(self.directionX == 0 and self.directionY== 0 and self.id == 1)then
		return
	end
	if(self.directionX == 0)then
		self.directionX = 1
		self.directionY = 0
		self.image = self.image_O
	end
end

function Head:moveUp()
	if(self.directionY == 0)then
		self.directionX = 0
		self.directionY = -1
		self.image = self.image_N
	end
end

function Head:moveDown()
	if(self.directionY == 0)then
		self.directionX = 0
		self.directionY = 1
		self.image = self.image_S
	end
end

function Head:checkGameOver()

	if(self.directionX == 0 and self.directionY == 0)then
		return;
	end

--GAME OVER ??
	collisionWithWall = (self.x < 20 or self.x > 1240 or self.y < 20 or self.y > 680) --WALL
	
	collisionWithSelf = false		-- SELF
	if(self.tailFront ~= nil) then
		collisionWithSelf = self.tailFront:checkCollision(self.x,self.y)
	end
	
	collisionWithEnemy = false		-- ENEMY
	 if(self.enemy ~= nil) then
		 if(self.enemy.tailFront ~= nil) then
			 collisionWithEnemy = self.enemy.tailFront:checkCollision(self.x,self.y)
		 end
		 if(collisionWithEnemy == false) then
			 collisionWithEnemy = self.enemy:checkCollision(self.x,self.y)
		 end
	 end
	 
	 --vibration dead
	 if(collisionWithSelf or collisionWithWall or collisionWithEnemy)then
		if(self.joystick ~= nil) then
			if(self.enemy ~= nil) then --2Player
				if(self.id == 1) then
					self.joystick:setVibration(0.4,0,0.3) --joyconLeft
				else
					self.joystick:setVibration(0,0.4,0.3) -- joyconRight
				end
			else --SinglePlayer
				self.joystick:setVibration(0.4,0.4,0.3) --joyconBoth
			end
		end
	 end
	 ----------------------------
	
	return (collisionWithSelf or collisionWithWall or collisionWithEnemy)
end

function Head:tailManagement(fruit)

	if(fruit:checkCollision(self.x,self.y)) then
		fruit:newFruit()
		self.points = self.points+1
		
		--vibration score+
		if(self.joystick ~= nil) then
			if(self.enemy ~= nil) then --2Player
				if(self.id == 1) then
					self.joystick:setVibration(0.2,0,0.1) --joyconLeft
				else
					self.joystick:setVibration(0,0.2,0.1) -- joyconRight
				end
			else --SinglePlayer
				self.joystick:setVibration(0.2,0.2,0.1) --joyconBoth
			end
		end
		-----------
		
		if(self.tailEnd == nil) then		-- FIRST TAIL GROWTH
			self.tailEnd = Tail(self.id,self.x,self.y,nil)
			self.tailFront = self.tailEnd
		else						-- OTHER GROWTH
			self.tailFront = Tail(self.id,self.x,self.y,self.tailFront)
			self.tailFront:getDown():setUp(self.tailFront)
		end
	else --NO COLLISION
		if(self.directionX == 0 and self.directionY == 0)then
			return;
		end
		if(self.tailEnd ~= nil) then
			self.tailFront = Tail(self.id,self.x,self.y,self.tailFront)
			down = self.tailFront:getDown()
			down:setUp(self.tailFront)
			self.tailEnd = self.tailEnd:getUp() 
			self.tailEnd:setDown(nil)  --GARBAGE COLLECTOR ???
		end
	end
end

function Head:getPoints()
	return self.points
end

function Head:checkCollision(x,y)
	return (self.x == x) and (self.y == y)
end

function Head:draw()
	if(self.directionX == -1 or (self.directionX == 0 and self.directionY == 0 and self.id == 1))then
		love.graphics.draw(self.image, self.x -14, self.y)
		return
	end
	if(self.directionY == -1)then
		love.graphics.draw(self.image, self.x, self.y -14)
		return
	end
	
	love.graphics.draw(self.image, self.x, self.y)

end

function Head:tailDraw()
	if(self.tailFront ~= nil) then
		self.tailFront:draw()
	end
end

function Head:move()
	self.x = self.x + self.directionX*40
	self.y = self.y + self.directionY*40
end

return Head()