class = require '30log'
require 'head'
fruit = require 'fruit'
require 'tail'
require 'timer'
require 'preload.preload'

preloadShrike = Preload("preload/assets/logoShrike.png","preload/assets/wuff.wav",200,500,200) -- FRAMES: 50 = FULLSCREEN | 300 = LOGO (small)
preloadLovePotion = Preload("preload/assets/logoLP.png","preload/assets/jingle.wav",250,460,160) -- FRAMES: 50 = FULLSCREEN | 300 = LOGO (small)
preloadMik = Preload("preload/assets/mikLogo.png",nil,250,460,160) -- FRAMES: 50 = FULLSCREEN | 300 = LOGO (small)

player1 = Head(1)
player2 = nil

dtotal = 0
joyconPair = nil
preloaderEnabled = true

gameoverFlag = false
twoPlayerMode = false

fruit:registerPlayers(player1,player2)	

fruit:newFruit()	

function love.load()  										---------- LOAD
	--love.graphics.setBackgroundColor(0.37, 0.44, 0.58)
	love.math.setRandomSeed(os.time())
	
	gameOverSoundTimer = Timer()
	gameoverFlag = false
	
	dtotal = 0 --gametime
	framespeed = 0.08
	
	gameOverSound = love.audio.newSource("graphics/gameover.wav", "static")
	bgMask = love.graphics.newImage("graphics/bg.png")
	
	bgSnake = love.graphics.newImage("graphics/bg2.png")
	bgP1 = love.graphics.newImage("graphics/player1win.png")
	bgP2 = love.graphics.newImage("graphics/player2win.png")
	bgDraw = love.graphics.newImage("graphics/draw.png")
	bgGO = love.graphics.newImage("graphics/gameover.png")
	
	bgTxt = bgSnake
	
	font = love.graphics.newFont(22)
	love.graphics.setFont(font)

end

function love.update(dt)									---------- UPDATE

	--GAME SPEED-------------------
	--gametime framespeed
	if dt < 1 then --error fix
	dtotal = dtotal + dt
	end
	if dtotal < framespeed then
		return --SKIP FRAME, DO NOTHING
    end
	dtotal = dtotal - framespeed --update gametime
	---------------------------------------------

	if(preloaderEnabled)then
		if(not (preloadLovePotion:getFinished() and preloadShrike:getFinished() and preloadMik:getFinished()))then  --PRELOADER WAIT
			return
		end
	end
	
	if(gameoverFlag) then  -- GAME OVER HANDLING
		wake = gameOverSoundTimer:isPast(3)
		if(wake) then
			player1:reset()
			if(player2 ~= nil) then
				player2:reset()
			end
			fruit:newFruit()
			gameoverFlag = false
		end
		return
	end
	
	if(twoPlayerMode) then --MULTIPLAYER HANDLING
		multiplayerEnd = multiplayerTimer:isPast(90) -- MULTIPLAYER TIME
		if(multiplayerEnd)then
			love.audio.play(gameOverSound)
			gameoverFlag = true
			gameOverSoundTimer:start()
		end
	end

	-------------PLAYER DIED ???
	p1GameOver = player1:checkGameOver()
	if(player2 ~= nil)then
		p2GameOver = player2:checkGameOver()
	end
	
	if(twoPlayerMode == false) then  -- SINGLE PLAYER GAME OVER CHECK
		if(p1GameOver or p2GameOver) then
			if(gameoverFlag == false) then
				love.audio.play(gameOverSound)
				gameoverFlag = true
				gameOverSoundTimer:start()
			end
		end
	end
	
	if(twoPlayerMode) then  --MULTIPLAYER PLAYER DIES
		if(p1GameOver) then
			player1:reset()
		end
		if(p2GameOver) then
			player2:reset()
		end
	end
	
	--------TAIL Move + Points
	player1:tailManagement(fruit)
	if(player2 ~= nil) then
		player2:tailManagement(fruit)
	end
	
	-------HeadMove
	player1:move()
	if(player2 ~= nil) then
		player2:move()
	end
end

function love.gamepadpressed(joystick, button) 			-------- GAMEPAD
	
	if(preloaderEnabled)then
		if(preloadShrike:checkSkip(joystick,button))then --Checks if preload is skipped
			return
		end
		if(preloadLovePotion:checkSkip(joystick,button))then --Checks if preload is skipped
			return
		end
		if(preloadMik:checkSkip(joystick,button))then --Checks if preload is skipped
			return
		end
	end
	
	--register joystick
	if(joyconPair == nil) then
		joyconPair = joystick
		player1:setJoystick(joyconPair)
	end
	
--ReadyPlayer2
	if(button == "plus")then 
		if(player2 == nil) then
			player2 = Head(2)
			player1:setEnemy(player2)
			player2:setEnemy(player1)
			multiplayerTimer = Timer()
			twoPlayerMode = true
			player2:setJoystick(joyconPair)
		end
		player1:reset()
		player2:reset()
		fruit:newFruit()
		multiplayerTimer:start()
		
		return
	end

-- PLAYER 1

	if(button == "dpleft")then
		player1:moveLeft()
		return
	elseif(button == "dpright")then
		player1:moveRight()
		return
	elseif(button == "dpup")then
		player1:moveUp()
		return
	elseif(button == "dpdown")then
		player1:moveDown()
		return
	end
	
-- PLAYER 2

	if(player2 ~= nil) then
		if(button == "y")then
			player2:moveLeft()
			return
		elseif(button == "a")then
			player2:moveRight()
			return
		elseif(button == "x")then
			player2:moveUp()
			return
		elseif(button == "b")then
			player2:moveDown()
			return
		end
	end
end

function love.gamepadaxis(joystick, axis, value)					-------- AXIS

	threshhold = 0.7

	--register joystick
	if(joyconPair == nil) then
		joyconPair = joystick
		player1:setJoystick(joyconPair)
	end

-- PLAYER 1
	if(axis == "leftx") then
		if(value > threshhold) then
			player1:moveRight()
			return
		elseif(value < -threshhold) then
			player1:moveLeft()
			return
		end
	elseif(axis == "lefty") then
		if(value > threshhold) then
			player1:moveDown()
			return
		elseif(value < -threshhold) then
			player1:moveUp()
			return
		end
	end
	
-- PLAYER 2
	if(player2 ~= nil) then
		if(axis == "rightx") then
			if(value > threshhold) then
				player2:moveRight()
				return
			elseif(value < -threshhold) then
				player2:moveLeft()
				return
			end
		elseif(axis == "righty") then
			if(value > threshhold) then
				player2:moveDown()
				return
			elseif(value < -threshhold) then
				player2:moveUp()
				return
			end
		end	
	end
	
end

function love.touchreleased(id,x,y,dx,dy,pressure)			-------- TOUCH POINT
	if(preloaderEnabled)then
		if(preloadShrike:getFinished() == false)then
			preloadShrike:setFinished()
			return
		end
		if(preloadLovePotion:getFinished() == false)then
			preloadLovePotion:setFinished()
			return
		end
		if(preloadMik:getFinished() == false)then
			preloadMik:setFinished()
			return
		end
	end
end

function love.draw()										------- DRAW
	
	-- PRELOADER DRAW() ---
	if(preloaderEnabled)then
		if(not preloadShrike:getFinished())then
			preloadShrike:draw()
			return
		end
		if(not preloadLovePotion:getFinished())then
			preloadLovePotion:draw()
			return
		end		
		if(not preloadMik:getFinished())then
			preloadMik:draw()
			return
		end
	end
	love.graphics.setColor(1,1,1,1)
	------------------------
	
	love.graphics.setBackgroundColor(0.37, 0.44, 0.58)
	
	if(gameoverFlag == false) then
		bgTxt = bgSnake
	else
		if(twoPlayerMode)then --MULTIPLAYER GAME OVER
			if(player1.points > player2.points)then
				bgTxt = bgP1
			elseif(player1.points < player2.points) then
				bgTxt = bgP2
			else
				bgTxt = bgDraw
			end
		else	--SINGLE PLAYER GAME OVER
				bgTxt = bgGO
		end
	end
	
	love.graphics.draw(bgMask, 0, 0)
	love.graphics.draw(bgTxt, 0, 0)
	
	--SCORE
	love.graphics.setColor(0.0,0.8,0.9,1)
	love.graphics.print("Score P1:", 268, 40)
	love.graphics.print(player1.points*10, 411, 40)
	if(twoPlayerMode)then
		love.graphics.setColor(0.98,0.19,0.05,1)
		love.graphics.print("Score P2:", 838, 40)
		love.graphics.print(player2.points*10, 982, 40)
		
		--Timer
		love.graphics.setColor(0,0,0,1)
		minutes = multiplayerTimer:getRestTimeMinutes(90)
		seconds = multiplayerTimer:getRestTimeSeconds(90)
		if(minutes < 10) then
			love.graphics.print("0" .. minutes, 600, 40)
		else
			love.graphics.print(minutes, 600, 40)
		end
		love.graphics.print(":", 640, 40)
		if(seconds < 10) then
			love.graphics.print("0" .. seconds, 660, 40)
		else
			love.graphics.print(seconds, 660, 40)
		end
	end
	love.graphics.setColor(1,1,1,1)
	
	if(gameoverFlag == false) then
		fruit:draw()
		player1:tailDraw()
		player1:draw()
		if(player2 ~= nil) then
			player2:tailDraw()
			player2:draw()
		end
	end
end